; canvas.s

	GET	macros.s

handle		*	0					; User handle
next_canvas	*	4					; Pointer to next (NULL means last)
window_handle	*	8
redraw_handler	*	12
open_handler	*	16
close_handler	*	20
pointer_handler	*	24
mouse_handler	*	28
key_handler	*	32
menu_creator	*	36
caret_handler	*	40
load_handler	*	44
save_handler	*	48
help_handler	*	52
flags		*	56
title		*	64
nzmouse_handler	*	128					; nz means when on an icon (used by icon.s)
nzcaret_handler	*	132
nzkey_handler	*	136
nzhelp_handler	*	140
nzmenu_creator	*	144
window		*	148					; Wimp_CreateWindow stuff
icon_list	*	236
scroll_handler	*	240
canvas_size	*	244

f_usenzmouse	*	1<<0					; Set if nz-values are to be used
f_usenzcaret	*	1<<1					; Set if nz-values are to be used
f_usenzkey	*	1<<2					; Set if nz-values are to be used
f_usenzhelp	*	1<<3					; Set if nz-values are to be used
f_usenzmenu	*	1<<4					; Set if nz-values are to be used

	AREA	|____canvas_init|, CODE
	EXPORT	canvas_init
canvas_init

	MACRO
$l	CLAIM	$a,$b
$l	MOV	r0,#$a
	ADR	r1,$b
	BL	main_addhandler
	MEND

	MACRO
$l	CLAIML	$a,$b
$l	MOV	r0,#$a
	ADRL	r1,$b
	BL	main_addhandler
	MEND

	MACRO
$l	WINOFFSETS	$w,$x,$y,$o
$l	ROUT
	LDR	r0,[r1,#$w]
	CMP	r0,#-2
	BEQ	%f00
	ADD	r1,r1,#$o
	STR	r0,[r1]
	SWI	XWimp_GetWindowState
	LDR	r0,[r1]
	SUB	r1,r1,#$o
	LDR	r2,[r1,#$o+20]
	LDR	r3,[r1,#$o+4]
	SUB	r3,r3,r2
	LDR	r2,[r1,#$x]
	SUB	r2,r2,r3
	STR	r2,[r1,#$x]
	LDR	r2,[r1,#$o+24]
	LDR	r3,[r1,#$o+16]
	SUB	r3,r3,r2
	LDR	r2,[r1,#$y]
	SUB	r2,r2,r3
	STR	r2,[r1,#$y]
00
	MEND

	IMPORT	main_addhandler

	STMFD	r13!,{r14}
	CLAIM	handler_redraw,canvas_redraww
	CLAIM	handler_open,canvas_openw
	CLAIM	handler_close,canvas_closew
	CLAIM	handler_enterwindow,canvas_pointer
	CLAIM	handler_leavewindow,canvas_pointer
	CLAIM	handler_mouse,canvas_mouse
	CLAIM	handler_key,canvas_key
	CLAIM	handler_losecaret,canvas_caret
	CLAIM	handler_gaincaret,canvas_caret
	CLAIML	handler_save,canvas_save
	CLAIML	handler_load,canvas_load
	CLAIML	handler_help,canvas_help
	CLAIML	handler_scroll,canvas_scroll
	LDR	r0,=canvas_iconbar
	MOV	r1,#-2
	STR	r1,[r0,#window_handle]
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

	IMPORT	|__draw_localx|
	IMPORT	|__draw_localy|

canvas_redraww
	STMFD	r13!,{r1,r4-r7,lr}
	LDR	r4,=canvas_redrawmode
	MOV	r5,#0
	STR	r5,[r4]
	SUB	r13,r13,#8
	LDR	r0,[r1]
	BL	canvas_find
	TEQ	r0,#0
	ADDEQ	r13,r13,#8
 [ arm32
	LDMEQFD	r13!,{r1,r4-r7,pc}
 |
	LDMEQFD	r13!,{r1,r4-r7,pc}^
 ]
	MOV	r7,r0
	SWI	XWimp_RedrawWindow
	STR	r1,[r13,#4]
	MOV	r12,r0
	LDR	r4,[r1,#4]
	LDR	r5,[r1,#20]
	SUB	r4,r4,r5
	MOV	r0,r4
	STR	r4,crw_tempx
	LDR	r4,[r1,#16]
	LDR	r5,[r1,#24]
	SUB	r4,r4,r5
	STR	r4,crw_tempy
	MOV	r5,r1
	MOV	r1,r4
	BL	store_gc
	MOV	r1,r5
	LDR	r6,[r7,#redraw_handler]
	MOV	r0,r12
crw_loop
	TEQ	r0,#0
	ADDEQ	r13,r13,#8
 [ arm32
	LDMEQFD	r13!,{r1,r4-r7,pc}
 |
	LDMEQFD	r13!,{r1,r4-r7,pc}^
 ]
;	TEQ	r7,#0
;	TEQNE	r6,#0
;	BEQ	crw_noexec
	MOV	r0,r7
	ADD	r1,r1,#28
	LDMIA	r1,{r1-r4}
	LDR	r5,crw_tempx
	SUB	r3,r3,r5
	SUB	r1,r1,r5
	LDR	r5,crw_tempy
	SUB	r4,r4,r5
	SUB	r2,r2,r5
	STR	r4,[r13]
	BL	restore_gc2
	TEQ	r7,#0
	TEQNE	r6,#0
	BEQ	crw_noexec
	MOV	lr,pc
	MOV	pc,r6
crw_noexec
	BL	restore_gc
;crw_noexec
	LDR	r1,[r13,#4]
	SWI	XWimp_GetRectangle
	B	crw_loop

crw_tempx
	DCD	0
crw_tempy
	DCD	0

	LTORG

canvas_openw2
	STMFD	r13!,{lr}
	B	canvas_openw3

canvas_openw
	STMFD	r13!,{lr}
	LDR	r0,[r1]
	BL	canvas_find
	TEQ	r0,#0
	BEQ	canvas_openuk
canvas_openw3
	LDR	r2,[r0,#open_handler]
	TEQ	r2,#0
	SWIEQ	XWimp_OpenWindow
	TEQ	r2,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	STR	r0,[r1]
	LDMFD	r13!,{lr}
	MOV	pc,r2

canvas_openuk
	SWI	XWimp_OpenWindow
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

canvas_closeuk
	SWI	XWimp_CloseWindow
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

canvas_closew
	STMFD	r13!,{lr}
	LDR	r0,[r1]
	BL	canvas_find
	TEQ	r0,#0
	BEQ	canvas_closeuk
	LDR	r2,[r0,#close_handler]
	TEQ	r2,#0
	SWIEQ	XWimp_CloseWindow
	TEQ	r2,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	STR	r0,[r1]
	LDMFD	r13!,{lr}
	MOV	pc,r2

canvas_pointer
	STMFD	r13!,{r0,lr}
	LDR	r0,[r1]
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r0,pc}
 |
	LDMEQFD	r13!,{r0,pc}^
 ]
	LDR	r2,[r0,#pointer_handler]
	TEQ	r2,#0
 [ arm32
	LDMEQFD	r13!,{r0,pc}
 |
	LDMEQFD	r13!,{r0,pc}^
 ]
	LDMFD	r13!,{r1,lr}
	SUB	r1,r1,#4
	MOV	pc,r2

;	=	"canvas_mouse",0
;	ALIGN

canvas_mouse
	STMFD	r13!,{lr}
	WINOFFSETS	12,0,4,20
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDR	r2,[r1,#8]
	TEQ	r2,#2
	BEQ	cmse_ismenu
	LDR	r2,[r1,#16]
	CMP	r2,#-1
	BEQ	cmse_noicon
	LDR	r2,[r0,#flags]
	TST	r2,#f_usenzmouse
	LDRNE	r2,[r0,#nzmouse_handler]
cmse_noicon
	LDREQ	r2,[r0,#mouse_handler]
	TEQ	r2,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDMFD	r13!,{lr}
	MOV	pc,r2

cmse_ismenu
	LDR	r2,[r1,#16]
	CMP	r2,#-1
	BEQ	cmnu_noicon
	LDR	r2,[r0,#flags]
	TST	r2,#f_usenzmenu
	LDRNE	r2,[r0,#nzmenu_creator]
cmnu_noicon
	LDREQ	r2,[r0,#menu_creator]
	TEQ	r2,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDMFD	r13!,{lr}
	MOV	pc,r2

canvas_key
	STMFD	r13!,{lr}
	WINOFFSETS	0,8,12,28
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDR	r2,[r1,#4]
	CMP	r2,#-1
	BEQ	ckey_noicon
	LDR	r2,[r0,#flags]
	TST	r2,#f_usenzkey
	LDRNE	r2,[r0,#nzkey_handler]
ckey_noicon
	LDREQ	r2,[r0,#key_handler]
	TEQ	r2,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDMFD	r13!,{lr}
	MOV	pc,r2

canvas_help
	STMFD	r13!,{lr}
	WINOFFSETS	32,20,24,40
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDR	r2,[r1,#36]
	CMP	r2,#-1
	BEQ	chlp_noicon
	LDR	r2,[r0,#flags]
	TST	r2,#f_usenzhelp
	LDRNE	r2,[r0,#nzhelp_handler]
chlp_noicon
	LDREQ	r2,[r0,#help_handler]
	TEQ	r2,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDMFD	r13!,{lr}
	ADD	r1,r1,#20
	MOV	pc,r2

canvas_caret
	STMFD	r13!,{r0,lr}
	WINOFFSETS	0,8,12,24
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r0,pc}
 |
	LDMEQFD	r13!,{r0,pc}^
 ]
	LDR	r2,[r1,#4]
	CMP	r2,#-1
	BEQ	ccrt_noicon
	LDR	r2,[r0,#flags]
	TST	r2,#f_usenzcaret
	LDRNE	r3,[r0,#nzcaret_handler]
ccrt_noicon
	LDREQ	r3,[r0,#caret_handler]
	TEQ	r3,#0
 [ arm32
	LDMEQFD	r13!,{r0,pc}
 |
	LDMEQFD	r13!,{r0,pc}^
 ]
	LDMFD	r13!,{r2,lr}
	SUB	r2,r2,#11
	MOV	pc,r3

canvas_save
	STMFD	r13!,{r4,lr}
	WINOFFSETS	20,28,32,220
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}
 |
	LDMEQFD	r13!,{r4,pc}^
 ]
	LDR	r4,[r0,#save_handler]
	TEQ	r4,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}
 |
	LDMEQFD	r13!,{r4,pc}^
 ]
	LDR	r2,[r1,#40]
	LDR	r3,[r1,#36]
	ADD	r1,r1,#44
	MOV	lr,pc
	MOV	pc,r4
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

canvas_load
	STMFD	r13!,{r4,lr}
	WINOFFSETS	20,28,32,220
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}
 |
	LDMEQFD	r13!,{r4,pc}^
 ]
	LDR	r4,[r0,#load_handler]
	TEQ	r4,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}
 |
	LDMEQFD	r13!,{r4,pc}^
 ]
	LDR	r2,[r1,#40]
	LDR	r3,[r1,#36]
	ADD	r1,r1,#44
	MOV	lr,pc
	MOV	pc,r4
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	EXPORT	canvas_find
canvas_find
	STMFD	r13!,{r1-r3,lr}
	LDR	r1,=first_canvas
	LDR	r1,[r1]
cfind_loop
	TEQ	r1,#0
	MOVEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r1-r3,pc}
 |
	LDMEQFD	r13!,{r1-r3,pc}^
 ]
	LDR	r2,[r1,#window_handle]
	TEQ	r2,r0
	MOVEQ	r0,r1
 [ arm32
	LDMEQFD	r13!,{r1-r3,pc}
 |
	LDMEQFD	r13!,{r1-r3,pc}^
 ]
	LDR	r1,[r1,#next_canvas]
	B	cfind_loop

	LTORG

store_gc
	STMFD	r13!,{r0-r1,lr}
	LDR	lr,=|__draw_localx|
	STMIA	lr,{r0,r1}
 [ arm32
;	MOV	pc,lr
 |
;	MOVS	pc,lr
 ]
;	STR	r0,destgc2
;	STR	r1,destgc2+4
;	ADR	r0,source_gc
;	ADR	r1,dest_gc
;	SWI	XOS_ReadVduVariables
 [ arm32
	LDMFD	r13!,{r0-r1,pc}
 |
	LDMFD	r13!,{r0-r1,pc}^
 ]

restore_gc
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]
;	STMFD	r13!,{r0,r1,lr}
;	SWI	&20100+29
;	ADR	r0,dest_gc
;	LDMIA	r0,{r0,r1}
;	SWI	&20000
;	MOV	r0,r0,ASR#8
;	SWI	&20000
;	MOV	r0,r1
;	SWI	&20000
;	MOV	r0,r0,ASR#8
;	SWI	&20000
 [ arm32
;	LDMFD	r13!,{r0,r1,pc}
 |
;	LDMFD	r13!,{r0,r1,pc}^
 ]

;source_gc
;	DCD	136,137,-1
;dest_gc	%	8
;destgc2
;	EXPORT	|___draw__originX|
;	EXPORT	|___draw__originY|
;|___draw__originX|
;	%	4
;|___draw__originY|
;	%	4

restore_gc2
	STMFD	r13!,{r0,r1,lr}
;	SWI	&20100+29
;	ADR	r0,destgc2
;	LDMIA	r0,{r0,r1}
;	SWI	&20000
;	MOV	r0,r0,ASR#8
;	SWI	&20000
;	MOV	r0,r1
;	SWI	&20000
;	MOV	r0,r0,ASR#8
;	SWI	&20000
 [ arm32
	LDMFD	r13!,{r0,r1,pc}
 |
	LDMFD	r13!,{r0,r1,pc}^
 ]

canvas_scroll
	STMFD	r13!,{lr}
	LDR	r0,[r1]
	BL	canvas_find
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDR	r2,[r1,#32]
	LDR	r3,[r1,#36]
	LDR	r12,[r0,#scroll_handler]
	TEQ	r12,#0
	BEQ	canvas_manualscroll
	STR	r0,[r1]
	LDMFD	r13!,{lr}
	MOV	pc,r12

canvas_manualscroll
	CMP	r2,#0
	BEQ	cms_nox
	CMP	r2,#-1
	MOVEQ	r2,#-8
	BEQ	cms_x
	CMP	r2,#1
	MOVEQ	r2,#8
	BEQ	cms_y
	LDR	r12,[r1,#12]
	LDR	r3,[r1,#4]
	CMP	r2,#0
	SUBPL	r2,r12,r3
	SUBMI	r2,r3,r12
	LDR	r3,[r1,#36]
cms_x	LDR	r12,[r1,#20]
	ADD	r2,r2,r12
	STR	r2,[r1,#20]
cms_nox	CMP	r3,#0
	BEQ	canvas_openw3
	CMP	r3,#-1
	MOVEQ	r3,#-8
	BEQ	cms_y
	CMP	r3,#1
	MOVEQ	r3,#8
	BEQ	cms_y
	LDR	r12,[r1,#12]
	LDR	r2,[r1,#4]
	CMP	r3,#0
	SUBPL	r3,r12,r2
	SUBMI	r3,r2,r12
cms_y	LDR	r12,[r1,#20]
	ADD	r3,r3,r12
	STR	r3,[r1,#20]
	B	canvas_openw3
	AREA	|__canvas_data|, DATA
first_canvas
	DCD	canvas_iconbar
	EXPORT	canvas_iconbar
canvas_iconbar
	DCD	0			; Handle
	DCD	canvas_iconbarright	; Next canvas
	DCD	-2			; Window handle
	%	canvas_size-12
	EXPORT	canvas_iconbarright
canvas_iconbarright
	DCD	0			; Handle
	DCD	0			; Next canvas
	DCD	-1			; Window handle
	%	canvas_size-12

	AREA	|____canvas_create|, CODE, READONLY
	EXPORT	canvas_create
canvas_create

; r0 is X size
; r1 is Y size
; r2 is ^ title
	STMFD	r13!,{r4-r6,lr}
	MOV	r4,r0
	ADD	r5,r1,#3
	ADD	r6,r2,#3
	BIC	r5,r5,#3
	BIC	r6,r6,#3
	MOV	r0,#canvas_size
	IMPORT	rmalloc
	BL	rmalloc
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4-r6,pc}
 |
	LDMEQFD	r13!,{r4-r6,pc}^
 ]
canvas_createwalloc
	MOV	r3,#0
	MOV	r2,#canvas_size-4
ccrt_clr
	STR	r3,[r0,r2]
	SUBS	r2,r2,#4
	BGT	ccrt_clr
	ADD	r3,r0,#window
	ADR	r1,default_window
	MOV	r2,#84
ccrt_copyloop
	LDR	lr,[r1,r2]
	STR	lr,[r3,r2]
	SUBS	r2,r2,#4
	BPL	ccrt_copyloop
	STR	r4,[r3,#8]
	STR	r4,[r3,#48]
	CMP	r5,#0
	STRPL	r5,[r3,#12]
	STRPL	r5,[r3,#52]
	STRMI	r5,[r3,#4]
	STRMI	r5,[r3,#44]
	MOV	r4,r6
	MOV	r5,r3
	LDR	r1,=first_canvas
	LDR	r3,[r1]
	STR	r0,[r1]
	MOV	r1,#0
	MOV	r2,#window-4
ccrt_clear
	STR	r1,[r0,r2]
	SUBS	r2,r2,#4
	BPL	ccrt_clear
	STR	r3,[r0,#next_canvas]
	ADD	r2,r0,#title
	STR	r2,[r5,#72]
ccrt_copytitle
	LDRB	r1,[r4],#1
	STRB	r1,[r2],#1
	CMP	r1,#32
	BGE	ccrt_copytitle
	MOV	r1,#0
	STRB	r1,[r2,#-1]
	STR	r1,[r0,#icon_list]
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

default_window
	DCD	0,0,0,0
	DCD	0,0
	DCD	-1,&87000012
	=	7,2,7,1,3,1,12,0
	DCD	0,0,0,0
	DCD	&27000119,&a000,1
	DCW	1,1
	DCD	0,-1,64,0

	LTORG

	AREA	|____canvas_addtolist|, CODE, READONLY
	EXPORT	canvas_addtolist
canvas_addtolist

; r0 is window#
	STMFD	r13!,{r4,lr}
	MOV	r4,r0
	MOV	r0,#canvas_size
	IMPORT	rmalloc
	BL	rmalloc
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}
 |
	LDMEQFD	r13!,{r4,pc}^
 ]
	LDR	r1,=first_canvas
	LDR	r3,[r1]
	STR	r0,[r1]
	MOV	r1,#0
	MOV	r2,#canvas_size-4
cadd_clear
	STR	r1,[r0,r2]
	SUBS	r2,r2,#4
	BGT	cadd_clear
	STR	r3,[r0,#next_canvas]
	STR	r4,[r0,#window_handle]
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____canvas_setsize|, CODE, READONLY
	EXPORT	canvas_setsize
canvas_setsize

	IMPORT	draw_shiftx
	IMPORT	draw_shifty

	LDR	r3,=draw_shiftx
	LDR	r3,[r3]
	MOV	r12,#-1
	MOV	r12,r12,LSL r3
	MVN	r12,r12
	CMP	r1,#0
	ADDGT	r1,r1,r3
	BIC	r1,r1,r3

	LDR	r3,=draw_shifty
	LDR	r3,[r3]
	MOV	r12,#-1
	MOV	r12,r12,LSL r3
	MVN	r12,r12
	CMP	r2,#0
	ADDGT	r2,r2,r3
	BIC	r2,r2,r3

	LDR	r3,[r0,#window_handle]
	TEQ	r3,#0
	BNE	cssz_created
	STR	r1,[r0,#window+48]
	CMP	r2,#0
	STRPL	r2,[r0,#window+52]
	STRMI	r2,[r0,#window+44]
	LDR	r3,[r0,#window+28]
	ORR	r3,r3,#&78<<24
	STR	r3,[r0,#window+28]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]
cssz_created
	STMFD	r13!,{r0,lr}
	STR	r1,[r0,#window+8]
	CMP	r2,#0
	STRPL	r2,[r0,#window+12]
	STRMI	r2,[r0,#window+4]
	MOV	r1,#0
	STRPL	r1,[r0,#window+4]
	STRMI	r1,[r0,#window+12]
	STR	r1,[r0,#window]
	ADD	r1,r0,#window
	MOV	r0,r3
	SWI	XWimp_SetExtent
	STR	r3,[r1]
	SWI	XWimp_GetWindowState
	LDR	r2,[r1,#32]
	TST	r2,#1<<16
 [ arm32
	LDMNEFD	r13!,{r0,pc}
 |
	LDMNEFD	r13!,{r0,pc}^
 ]
	BNE	canvas_openw3
 [ arm32
	LDMFD	r13!,{r0,pc}
 |
	LDMFD	r13!,{r0,pc}^
 ]

	AREA	|____canvas_setfullsize|, CODE, READONLY
	EXPORT	canvas_setfullsize
canvas_setfullsize

	MOV	r12,r13
	STMFD	r13!,{r4,r5,lr}
	LDR	r4,[r12]
	LDR	r5,=draw_shiftx
	LDR	r5,[r5]
	MOV	lr,#-1
	MOV	lr,lr,LSL r5
	MVN	lr,lr

	BIC	r1,r1,lr
	ADD	r3,r3,lr
	BIC	r3,r3,lr

	LDR	r5,=draw_shifty
	LDR	r5,[r5]
	MOV	lr,#-1
	MOV	lr,lr,LSL r5
	MVN	lr,lr

	BIC	r2,r2,lr
	ADD	r4,r4,lr
	BIC	r4,r4,lr

	LDR	lr,[r0,#window_handle]
	TEQ	lr,#0
	BNE	csfsz_created
	ADD	r5,r0,#window+40
	STMIA	r5,{r1-r4}
	LDR	r3,[r0,#window+28]
	ORR	r3,r3,#&78<<24
	STR	r3,[r0,#window+28]
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]
csfsz_created
 [ arm32
;	LDMFD	r13!,{r4,r5,pc}
 |
;	LDMFD	r13!,{r4,r5,pc}^
 ]
	STMFD	r13!,{r0}
	ADD	r5,r0,#window
	STMIA	r5,{r1-r4}
	ADD	r1,r0,#window
	MOV	r0,lr
	SWI	XWimp_SetExtent
	STR	lr,[r1]
	SWI	XWimp_GetWindowState
	LDR	r2,[r1,#32]
	TST	r2,#1<<16
	LDMNEFD	r13!,{r0,r4,r5}
	BNE	canvas_openw3
;	SWINE	XWimp_OpenWindow
 [ arm32
	LDMFD	r13!,{r0,r4-r5,pc}
 |
	LDMFD	r13!,{r0,r4-r5,pc}^
 ]

	AREA	|____canvas_handle|, CODE, READONLY
	EXPORT	canvas_handle
canvas_handle

	LDR	r0,[r0,#window_handle]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_setflags|, CODE, READONLY
	EXPORT	canvas_setflags
canvas_setflags

; r0 is ^ canvas
; r1 is BIC mask
; r2 is OR mask
; data=(data AND NOT r1) OR r2
	STMFD	r13!,{r4,r5,lr}
	AND	r4,r1,#&f0000
	AND	r5,r2,#&f0000
	BIC	r1,r1,#&f0000
	BIC	r2,r2,#&f0000
	LDR	r3,[r0,#window+28]
	BIC	r3,r3,r1
	ORR	r3,r3,r2
	STR	r3,[r0,#window+28]
	LDR	r3,[r0,#window+60]
	BIC	r3,r3,r4,LSR#4
	ORR	r3,r3,r5,LSR#4
	STR	r3,[r0,#window+60]
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____canvas_colour|, CODE, READONLY
	EXPORT	canvas_colour
canvas_colour

	STRB	r1,[r0,#window+35]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_open|, CODE, READONLY
	EXPORT	canvas_open
canvas_open

	STMFD	r13!,{lr}
	ADD	r2,r0,#window
	MOV	r3,#28
copn_loop
	LDR	lr,[r1,r3]
	STR	lr,[r2,r3]
	SUBS	r3,r3,#4
	BGT	copn_loop
	MOV	r1,r2
	LDR	r3,[r0,#window_handle]
	STR	r3,[r1]
	SWI	XWimp_OpenWindow
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

	AREA	|____canvas_close|, CODE, READONLY
	EXPORT	canvas_close
canvas_close

	ADD	r1,r0,#window_handle
	SWI	XWimp_CloseWindow
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_make|, CODE, READONLY
	EXPORT	canvas_make
canvas_make

	LDR	r3,[r0,#redraw_handler]
	TEQ	r3,#0
	BEQ	cm_rh
	LDR	r3,[r0,#window+28]
	BIC	r3,r3,#1<<4
	STR	r3,[r0,#window+28]
cm_rh	MOV	r2,r0
	ADD	r1,r0,#window
	LDR	r3,[r1,#0]
	ADD	r3,r3,#32
	STR	r3,[r1,#0]
	LDR	r3,[r1,#4]
	ADD	r3,r3,#192
	STR	r3,[r1,#4]
	LDR	r3,[r1,#8]
	ADD	r3,r3,#32
	STR	r3,[r1,#8]
	LDR	r3,[r1,#12]
	ADD	r3,r3,#192
	STR	r3,[r1,#12]
	SWI	XWimp_CreateWindow
	STRVC	r0,[r2,#window_handle]
	MOVVS	r0,#0
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_makeatlocation|, CODE, READONLY
	EXPORT	canvas_makeatlocation
canvas_makeatlocation

; r0 is canvas
; r1 is x
; r2 is y
; These are canvas (0,0) location!

	STMFD	r13!,{lr}
	MOV	r12,r1
	MOV	r14,r2
	LDR	r3,[r0,#redraw_handler]
	TEQ	r3,#0
	BEQ	cmal_rh
	LDR	r3,[r0,#window+28]
	BIC	r3,r3,#1<<4
	STR	r3,[r0,#window+28]
cmal_rh	MOV	r2,r0
	ADD	r1,r0,#window
	LDR	r3,[r1,#0]
	ADD	r3,r3,r12
	STR	r3,[r1,#0]
	LDR	r3,[r1,#4]
	ADD	r3,r3,r14
	STR	r3,[r1,#4]
	LDR	r3,[r1,#8]
	ADD	r3,r3,r12
	STR	r3,[r1,#8]
	LDR	r3,[r1,#12]
	ADD	r3,r3,r14
	STR	r3,[r1,#12]
	SWI	XWimp_CreateWindow
	STRVC	r0,[r2,#window_handle]
	MOVVS	r0,#0
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

	AREA	|____canvas_makeatlocationsize|, CODE, READONLY
	EXPORT	canvas_makeatlocationsize
canvas_makeatlocationsize

; r0 is canvas
; r1 is x
; r2 is y
; r3 is width
; !r13 is height
; These are canvas (0,0) location!

	LDR	r12,[r13]
	STMFD	r13!,{r4,r5,lr}
	MOV	r5,r12
	MOV	r4,r3
	MOV	r12,r1
	MOV	r14,r2
	LDR	r3,[r0,#redraw_handler]
	TEQ	r3,#0
	BEQ	cmals_rh
	LDR	r3,[r0,#window+28]
	BIC	r3,r3,#1<<4
	STR	r3,[r0,#window+28]
cmals_rh
	MOV	r2,r0
	ADD	r1,r0,#window
	LDR	r3,[r1,#0]
	ADD	r3,r3,r12
	STR	r3,[r1,#0]
	ADD	r3,r3,r4
	STR	r3,[r1,#8]
	LDR	r3,[r1,#4]
	ADD	r3,r3,r14
	STR	r3,[r1,#4]
	ADD	r3,r3,r5
	STR	r3,[r1,#12]
;	LDR	r3,[r1,#8]
;	ADD	r3,r3,r12
;	STR	r3,[r1,#8]
;	LDR	r3,[r1,#12]
;	ADD	r3,r3,r14
;	STR	r3,[r1,#12]
	SWI	XWimp_CreateWindow
	STRVC	r0,[r2,#window_handle]
	MOVVS	r0,#0
 [ arm32
	LDMFD	r13!,{r4, r5, pc}
 |
	LDMFD	r13!,{r4, r5, pc}^
 ]

	AREA	|____canvas_remove|, CODE, READONLY
	EXPORT	canvas_remove
canvas_remove

	IMPORT	rfree
	LDR	r2,[r0,#next_canvas]
	LDR	r1,=first_canvas
crmv_loop
	LDR	r3,[r1]
	TEQ	r3,r0
	STREQ	r2,[r1]
	BEQ	crmv_cut
	ADDS	r1,r3,#next_canvas
	CMP	r3,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	B	crmv_loop
crmv_cut
	MOV	r2,r0
	ADD	r1,r0,#window_handle
	SWI	XWimp_DeleteWindow
	MOV	r0,r2
	STMFD	r13!,{r0,r4,lr}
	LDR	r4,[r0,#icon_list]
crmv_icons
	TEQ	r4,#0
	BEQ	crmv_noicons
	MOV	r0,r4
	LDR	r4,[r4,#0]
	BL	rfree
crmv_noicons
	LDMFD	r13!,{r0,r4,lr}
	MOV	r0,r2
	B	rfree

	LTORG

	AREA	|____canvas_removeallocated|, CODE, READONLY
	EXPORT	canvas_removeallocated
canvas_removeallocated

	LDR	r2,[r0,#next_canvas]
	LDR	r1,=first_canvas
crmva_loop
	LDR	r3,[r1]
	TEQ	r3,r0
	STREQ	r2,[r1]
	BEQ	crmva_cut
	ADDS	r1,r3,#next_canvas
	CMP	r3,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	B	crmva_loop
crmva_cut
	MOV	r2,r0
	ADD	r1,r0,#window_handle
	SWI	XWimp_DeleteWindow
	MOV	r0,r2
	STMFD	r13!,{r0,r4,lr}
	LDR	r4,[r0,#icon_list]
crmva_icons
	TEQ	r4,#0
	BEQ	crmva_noicons
	MOV	r0,r4
	LDR	r4,[r4,#0]
	BL	rfree
crmva_noicons
 [ arm32
	LDMFD	r13!,{r0,r4,pc}
 |
	LDMFD	r13!,{r0,r4,pc}^
 ]

	LTORG

	AREA	|____canvas_forceredraw|, CODE, READONLY
	EXPORT	canvas_forceredraw
canvas_forceredraw

	LDR	r0,[r0,#window_handle]
;	ADD	r1,r0,#window
;	STR	r2,[r1]
;	MOV	r3,r0
;	SWI	XWimp_GetWindowState
	STMFD	r13!,{r4-r6,lr}
;	LDMIA	r1,{r0-r6}
;	SUB	r3,r3,r1			; WIDTH
;	SUB	r2,r4,r2			; HEIGHT
;	MOV	r1,r5				; X0=scx
;	MOV	r4,r6				; Y1=scy
;	SUB	r2,r2,r4			; Y0=scy-HEIGHT
;	ADD	r3,r3,r1			; X1=scx+WIDTH
	MOV	r3,#1<<16
	MOV	r4,#1<<16
	RSB	r1,r3,#0
	RSB	r2,r4,#0
	SWI	XWimp_ForceRedraw
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____canvas_redraw|, CODE, READONLY
	EXPORT	canvas_redraw
canvas_redraw

	LDR	r0,[r0,#window_handle]
	STMFD	r13!,{r4,lr}
	LDR	r4,[r13,#8]
	SWI	XWimp_ForceRedraw
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____canvas_opencentre|, CODE, READONLY
	EXPORT	canvas_opencentre
canvas_opencentre

	IMPORT	draw_maxx
	IMPORT	draw_maxy

	STMFD	r13!,{r0,lr}
	ADD	r1,r0,#window
	LDR	r2,[r0,#window_handle]
	STR	r2,[r1]
	SWI	XWimp_GetWindowState
	LDR	r3,=draw_maxx
	LDR	r3,[r3]
	MOV	r3,r3,LSR#1
	LDR	r0,[r1,#4]
	LDR	r2,[r1,#12]
	SUB	r0,r2,r0
	ADD	r2,r3,r0,LSR#1
	SUB	r0,r3,r0,LSR#1
	STR	r2,[r1,#12]
	STR	r0,[r1,#4]
	LDR	r3,=draw_maxy
	LDR	r3,[r3]
	MOV	r3,r3,LSR#1
	LDR	r0,[r1,#8]
	LDR	r2,[r1,#16]
	SUB	r0,r2,r0
	ADD	r2,r3,r0,LSR#1
	SUB	r0,r3,r0,LSR#1
	STR	r2,[r1,#16]
	STR	r0,[r1,#8]
	MOV	r0,#-1
	STR	r0,[r1,#28]
	LDMFD	r13!,{r0}
	B	canvas_openw3

	LTORG

	AREA	|____canvas_opencentrebottom|, CODE, READONLY
	EXPORT	canvas_opencentrebottom
canvas_opencentrebottom

	STMFD	r13!,{r0,lr}
	ADD	r1,r0,#window
	LDR	r2,[r0,#window_handle]
	STR	r2,[r1]
	SWI	XWimp_GetWindowState
	LDR	r3,=draw_maxx
	LDR	r3,[r3]
	MOV	r3,r3,LSR#1
	LDR	r0,[r1,#4]
	LDR	r2,[r1,#12]
	SUB	r0,r2,r0
	ADD	r2,r3,r0,LSR#1
	SUB	r0,r3,r0,LSR#1
	STR	r2,[r1,#12]
	STR	r0,[r1,#4]
	LDR	r3,=draw_maxy
	LDR	r3,[r3]
	MOV	r3,r3,LSR#1
	LDR	r0,[r1,#8]
	LDR	r2,[r1,#16]
	SUB	r0,r2,r0
	ADD	r2,r3,r0,LSR#1
	SUB	r0,r3,r0,LSR#1
	STR	r2,[r1,#16]
	STR	r0,[r1,#8]
	MOV	r0,#-2
	STR	r0,[r1,#28]
	LDMFD	r13!,{r0}
	B	canvas_openw3

	LTORG

	AREA	|____canvas_opentop|, CODE, READONLY
	EXPORT	canvas_opentop
canvas_opentop

	STMFD	r13!,{r0,r4,r5,lr}
	MOV	r4,r1
	MOV	r5,r2
	ADD	r1,r0,#window
	LDR	r2,[r0,#window_handle]
	STR	r2,[r1]
	SWI	XWimp_GetWindowState
	LDR	r0,[r1,#4]
	LDR	r2,[r1,#12]
	SUB	r2,r2,r0
	ADD	r2,r2,r4
	STR	r4,[r1,#4]
	STR	r2,[r1,#12]
	LDR	r0,[r1,#8]
	LDR	r2,[r1,#16]
	SUB	r2,r2,r0
	ADD	r2,r2,r5
	STR	r5,[r1,#8]
	STR	r2,[r1,#16]
	MOV	r0,#-1
	STR	r0,[r1,#28]
	LDMFD	r13!,{r0,r4,r5}
	B	canvas_openw3

	AREA	|____canvas_addhandler|, CODE, READONLY
	EXPORT	canvas_addhandler
canvas_addhandler

	CMP	r1,#11
	BGE	cah_2
	ADD	r0,r0,r1,LSL#2
	LDR	r1,[r0,#redraw_handler]
	STR	r2,[r0,#redraw_handler]
	MOV	r0,r1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

cah_2	SUB	r1,r1,#11
	ADD	r0,r0,r1,LSL#2
	LDR	r1,[r0,#scroll_handler]
	STR	r2,[r0,#scroll_handler]
	MOV	r0,r1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_settitle|, CODE, READONLY
	EXPORT	canvas_settitle
canvas_settitle

	STMFD	r13!,{r4,lr}
	ADD	r3,r0,#title
csett_copy
	LDRB	r2,[r1],#1
	STRB	r2,[r3],#1
	CMP	r2,#32
	BGE	csett_copy
	MOV	r3,r0
	ADD	r1,r0,#window
	LDR	r0,[r0,#window_handle]
	STR	r0,[r1]
	SWI	XWimp_GetWindowOutline
	LDMIB	r1,{r1-r4}
	MOV	r0,#-1
	SUB	r2,r4,#44
	SWI	XWimp_ForceRedraw
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____canvas_createallocated|, CODE, READONLY
	EXPORT	canvas_createallocated
canvas_createallocated

; r0 is X size
; r1 is Y size
; r2 is ^ title
; r3 is ^ canvas
	STMFD	r13!,{r4-r6,lr}
	MOV	r4,r0
	ADD	r5,r1,#3
	ADD	r6,r2,#3
	BIC	r5,r5,#3
	BIC	r6,r6,#3
	MOVS	r0,r3
 [ arm32
	LDMEQFD	r13!,{r4-r6,pc}
 |
	LDMEQFD	r13!,{r4-r6,pc}^
 ]
	B	canvas_createwalloc
 [ 0=1
	ADD	r3,r0,#window
	ADR	r1,default_windowa
	MOV	r2,#84
ccrta_copyloop
	LDR	lr,[r1,r2]
	STR	lr,[r3,r2]
	SUBS	r2,r2,#4
	BPL	ccrta_copyloop
	STR	r4,[r3,#8]
	STR	r4,[r3,#48]
	STR	r5,[r3,#12]
	STR	r5,[r3,#52]
	MOV	r4,r6
	MOV	r5,r3
	LDR	r1,=first_canvas
	LDR	r3,[r1]
	STR	r0,[r1]
	MOV	r1,#0
	MOV	r2,#window-4
ccrta_clear
	STR	r1,[r0,r2]
	SUBS	r2,r2,#4
	BPL	ccrta_clear
	STR	r3,[r0,#next_canvas]
	ADD	r2,r0,#title
	STR	r2,[r5,#72]
ccrta_copytitle
	LDRB	r1,[r4],#1
	STRB	r1,[r2],#1
	CMP	r1,#32
	BGE	ccrta_copytitle
	MOV	r1,#0
	STRB	r1,[r2,#-1]
	STR	r1,[r0,#icon_list]
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

default_windowa
	DCD	0,0,0,0
	DCD	0,0
	DCD	-1,&87000002
	=	7,2,7,1,3,1,12,0
	DCD	0,0,0,0
	DCD	&27000119,&a000,1
	DCW	1,1
	DCD	0,-1,64,0
 ]

	LTORG

	AREA	|____canvas_setspritearea|, CODE, READONLY
	EXPORT	canvas_setspritearea
canvas_setspritearea

	STR	r1,[r0,#window+64]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_reopen|, CODE, READONLY
	EXPORT	canvas_reopen
canvas_reopen

	LDR	r2,[r0,#window_handle]
	STR	r2,[r0,#window]!
	MOV	r1,r0
	SWI	XWimp_GetWindowState
	MOV	r0,#-1
	STR	r0,[r1,#28]
	SWI	XWimp_OpenWindow
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_forceupdate|, CODE
	EXPORT	canvas_forceupdate
canvas_forceupdate

; r0 is ^ canvas
; r1 is ^ proc
	STMFD	r13!,{r4-r5,lr}
	MOV	r5,r1
	MOV	r3,#1<<20
	MOV	r4,r3
	RSB	r2,r4,#0
	RSB	r1,r3,#0
	STMFD	r13!,{r4,r5}
	BL	canvas_update
	ADD	r13,r13,#8
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]
	LTORG

	AREA	|____canvas_windowptr|, CODE, READONLY
	EXPORT	canvas_windowptr
canvas_windowptr

	ADD	r0,r0,#window
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_update|, CODE
	EXPORT	canvas_update
canvas_update

; r0 is ^ canvas
; r1 is x0
; r2 is y0
; r3 is x1
;!r12 is x2
;r12!4 is ^ proc
	MOV	r12,r13
	STMFD	r13!,{r4-r7,lr}
	LDR	r4,=canvas_redrawmode
	MOV	r5,#1
	STR	r5,[r4]
	LDR	r4,[r12,#4]
	STR	r4,cud_proc
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	LDR	r5,[r12]
	MOV	r7,r0
	MOV	r1,r0
	LDR	r0,[r0,#window_handle]
	STR	r0,[r1,#window]!
	MOV	r0,r1
	STMFD	r13!,{r0,r1}
	SUB	r13,r13,#4
;	STR	r1,[r13,#4]
;	MOV	r2,#1<<31
;	MOV	r3,#1<<31
;	MOV	r4,#1<<30
;	MOV	r5,#1<<30
	STMIB	r1,{r2-r5}
	SWI	XWimp_UpdateWindow
	MOV	r12,r0
	LDR	r4,[r1,#4]
	LDR	r5,[r1,#20]
	SUB	r4,r4,r5
	STR	r4,cud_tempx
	MOV	r0,r4
	LDR	r4,[r1,#16]
	LDR	r5,[r1,#24]
	SUB	r4,r4,r5
	STR	r4,cud_tempy
	MOV	r5,r1
	MOV	r1,r4
	BL	store_gc
	MOV	r1,r5
	LDR	r6,cud_proc
	MOV	r0,r12
;	SWI	&20100+4
;	SWI	&20100+30
cud_loop
	TEQ	r0,#0
	ADDEQ	r13,r13,#8
 [ arm32
	LDMEQFD	r13!,{r1,r4-r7,pc}
 |
	LDMEQFD	r13!,{r1,r4-r7,pc}^
 ]
;	SWI	&20100+4
;	SWI	&20100+'.'
	TEQ	r6,#0
	BEQ	cud_noexec
	MOV	r0,r7
	ADD	r1,r1,#28
	LDMIA	r1,{r1-r4}
	LDR	r5,cud_tempx
	SUB	r3,r3,r5
	SUB	r1,r1,r5
	LDR	r5,cud_tempy
	SUB	r4,r4,r5
	SUB	r2,r2,r5
	STR	r4,[r13]
	BL	restore_gc2
	MOV	lr,pc
	MOV	pc,r6
	BL	restore_gc
cud_noexec
	LDR	r1,[r13,#4]
	SWI	XWimp_GetRectangle
	B	cud_loop

cud_tempx
	DCD	0
cud_tempy
	DCD	0
cud_proc
	DCD	0

	LTORG

	AREA	|____canvas_getcanvasstate|, CODE, READONLY
	EXPORT	canvas_getcanvasstate
canvas_getcanvasstate

	LDR	r0,[r0,#window_handle]
	STR	r0,[r1]
	SWI	XWimp_GetWindowState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_getpointerlocation|, CODE
	EXPORT	canvas_getpointerlocation
canvas_getpointerlocation

; r0 is ^ canvas
; r1 is ^ x variable
; r2 is ^ y variable

	STMFD	r13!,{r1-r2,r4,r5,lr}
	ADR	r4,cgpl_temp
	LDR	r5,[r0,#window_handle]
	MOV	r1,r4
	SWI	XWimp_GetPointerInfo
cgpl_doit
	STR	r5,[r1,#12]
	WINOFFSETS 12,0,4,20
	MOV	r0,r4
	LDMFD	r13!,{r1-r2,r4,r5,lr}
	LDR	r3,[r0]
	STR	r3,[r1]
	LDR	r3,[r0,#4]
	STR	r3,[r2]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

cgpl_temp
	%	80

	EXPORT	canvas_getlocation
canvas_getlocation
; r0 is ^ canvas
; r1 is ^ x location which is modified to canvas location
; r2 is ^ y location which is modified to canvas location

	STMFD	r13!,{r1-r2,r4,r5,lr}
	LDR	r3,[r1]
	LDR	r5,[r2]
	ADR	r1,cgpl_temp
	MOV	r4,r1
	STMIA	r1,{r3,r5}
	LDR	r5,[r0,#window_handle]
	B	cgpl_doit

	AREA	|____canvas_getorigin|, CODE, READONLY
	EXPORT	canvas_getorigin
canvas_getorigin

	STMFD	r13!,{r1-r2,r4,r5,lr}
	ADR	r4,cgo_temp
	LDR	r5,[r0,#window_handle]
	MOV	r1,r4
	MOV	r2,#0
	STR	r2,[r1]
	STR	r2,[r1,#4]
	STR	r5,[r1,#12]
	WINOFFSETS 12,0,4,20
	MOV	r0,r4
	LDMFD	r13!,{r1-r2,r4,r5,lr}
	LDR	r3,[r0]
	STR	r3,[r1]
	LDR	r3,[r0,#4]
	STR	r3,[r2]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

cgo_temp
	%	80

	AREA	|____canvas_claimcaret|, CODE, READONLY
	EXPORT	canvas_claimcaret
canvas_claimcaret

	STMFD	r13!,{r4-r5,lr}
	LDR	r0,[r0,#window_handle]
	MOV	r1,#-1
	MOV	r2,#0
	MOV	r3,#0
	MOV	r4,#-1
	MOV	r5,#-1
	SWI	XWimp_SetCaretPosition
 [ arm32
	LDMFD	r13!,{r4-r5,pc}
 |
	LDMFD	r13!,{r4-r5,pc}^
 ]

	AREA	|____canvas_getrawmouse|, CODE, READONLY
	EXPORT	canvas_getrawmouse
canvas_getrawmouse

	MOV	r1,r0
	SWI	XWimp_GetPointerInfo
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_setoutlinecolour|, CODE, READONLY
	EXPORT	canvas_setoutlinecolour
canvas_setoutlinecolour

	STRB	r1,[r0,#window+32]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_setidhandle|, CODE, READONLY
	EXPORT	canvas_setidhandle
canvas_setidhandle

	STR	r1,[r0]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_idhandle|, CODE, READONLY
	EXPORT	canvas_idhandle
canvas_idhandle

	LDR	r0,[r0]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	canvas_templatefile, DATA, NOINIT
	%	256

	AREA	canvas_templatespritearea, DATA
	DCD	1

	AREA	|____canvas_templatesetspritearea|, CODE, READONLY
	EXPORT	canvas_templatesetspritearea
canvas_templatesetspritearea

	LDR	r1,=canvas_templatespritearea
	STR	r0,[r1]

	AREA	|____canvas_templateopen|, CODE, READONLY
	EXPORT	canvas_templateopen
canvas_templateopen

	STMFD	r13!,{r4-r5,lr}
	MOV	r1,r0
	LDR	r0,=canvas_templatefile
	MOV	r3,r0
cto1	LDRB	r2,[r1],#1
	CMP	r2,#32
	STRCSB	r2,[r3],#1
	BCS	cto1
	MOV	r2,#0
	STRB	r2,[r3]
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	TEQ	r0,#1
	MOVNE	r0,#0
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	canvas_templatetemp, DATA
	%	64

	^	0,r13
ctc_nicons	#	4
ctc_iconwin	#	4
ctc_iconfield	#	0
ctc_iconcoords	#	16
ctc_iconflags	#	4
ctc_icondata	#	12
ctc_iconoffset	#	4
ctc_iconno	#	4
ctc_end		#	0
ctc_size	*	ctc_end-ctc_nicons

	AREA	|____canvas_templatecanvas|, CODE, READONLY
	EXPORT	canvas_templatecanvas
canvas_templatecanvas

; r0 is template name (ctrl-terminated, case sensitive)
; Routine will automatically rmalloc memory for the stuff.

	STMFD	r13!,{r4-r9,lr}
	MOV	r9,r0

	LDR	r1,=canvas_templatefile
	MOV	r0,#64
	SWI	XOS_Find
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{r4-r9,pc}
 |
	LDMVSFD	r13!,{r4-r9,pc}^
 ]

	LDR	r7,=canvas_templatetemp
	MOV	r6,r0

ctc_getentries
	MOV	r4,#16
	MOV	r3,#24
	MOV	r2,r7
	MOV	r1,r6
	MOV	r0,#3
	SWI	XOS_GBPB
	BCS	ctc_failure1
	BVS	ctc_failure1

	LDR	r0,[r7,#0]
	TEQ	r0,#0
	BEQ	ctc_failure1

	ADD	r0,r7,#12
	MOV	r2,#0
ctc_checkentry
	LDRB	r1,[r0,r2]
	LDRB	r3,[r9,r2]
	TEQ	r1,r3
	BNE	ctc_checkwildcard
	ADD	r2,r2,#1
	TEQ	r2,#12
	BNE	ctc_checkentry
	B	ctc_gotentry
ctc_checkwildcard
	CMP	r1,#32
	CMPCC	r3,#32
	BCC	ctc_gotentry
	TEQ	r3,#'*'
	BNE	ctc_getentries
ctc_gotentry
	LDR	r4,[r7,#0]

	MOV	r0,#canvas_size
	BL	rmalloc
	TEQ	r0,#0
	BEQ	ctc_failure1

	LDR	r1,=first_canvas
	LDR	r3,[r1]
	STR	r0,[r1]

	MOV	r8,r0
	MOV	r2,#canvas_size
	MOV	r1,#0
ctc_clearloop
	STR	r1,[r0],#4
	SUBS	r2,r2,#4
	BGT	ctc_clearloop

	STR	r3,[r8,#next_canvas]

	MOV	r5,r4
	MOV	r3,#88
	ADD	r2,r8,#window
	MOV	r1,r6
	MOV	r0,#3
	SWI	XOS_GBPB
	BVS	ctc_failure2
	BCS	ctc_failure2

	SUB	r13,r13,#ctc_size
	LDR	r0,[r8,#window+84]
	STR	r0,ctc_nicons
	MOV	r0,#0
	STR	r0,[r8,#window+84]
	LDR	r0,[r8,#window+56]
	TST	r0,#256
	ORR	r0,r0,#256
	STR	r0,[r8,#window+56]
	MOVEQ	r0,#72
	MOVEQ	r1,#12
	LDRNE	r0,[r8,#window+72]
	LDRNE	r1,[r8,#window+80]
	CMP	r1,#64
	MOVGT	r1,#64
	ADD	r0,r0,r5
	ADD	r2,r8,#title
	STR	r2,[r8,#window+72]
	MOV	r3,#-1
	STR	r3,[r8,#window+76]
	MOV	r3,#64
	STR	r3,[r8,#window+80]
	MOV	r3,r6
	BL	ctc_readstring
	BVS	ctc_failure3

	LDR	r0,=canvas_templatespritearea
	LDR	r0,[r0]
	STR	r0,[r8,#window+64]
	ADD	r1,r8,#window
	SWI	XWimp_CreateWindow
	BVS	ctc_failure3

	STR	r0,[r8,#window_handle]

	LDR	r0,ctc_nicons
	TEQ	r0,#0
	BEQ	ctc_endicons

	MOV	r0,#0
	STR	r0,ctc_iconno

ctc_createicons
	ADD	r0,r5,r0,LSL#5
	ADD	r0,r0,#88
	MOV	r1,#32
	ADR	r2,ctc_iconfield
	MOV	r3,r6
	BL	ctc_readblock
	BVS	ctc_failure4
	LDR	r0,ctc_iconflags
	TST	r0,#256
	BEQ	ctc_createicon
	AND	r0,r0,#3
	ADD	pc,pc,r0,LSL#2
	DCD	0
	B	ctc_createicon
	B	ctc_createtext
	B	ctc_createsprite
ctc_createtext
	LDR	r0,ctc_icondata+4
	CMP	r0,#-1
	MOVEQ	r0,#0
	BEQ	ctc_skipvalid

	ADD	r0,r0,r5
	MOV	r1,#256
	MOV	r2,#0
	MOV	r3,r6
	BL	ctc_readstring
	BVS	ctc_failure4
ctc_skipvalid

	LDR	r1,ctc_icondata+8
	ADD	r0,r0,r1
	ADD	r0,r0,#7
	BIC	r0,r0,#3
	BL	rmalloc
	TEQ	r0,#0
	BEQ	ctc_failure4

	STR	r0,ctc_iconoffset
	LDR	r0,ctc_icondata
	ADD	r0,r0,r5
	LDR	r1,ctc_icondata+8
	LDR	r2,ctc_iconoffset
	STR	r2,ctc_icondata
	MOV	r3,r6
	BL	ctc_readstring
	BVS	ctc_failure4

	LDR	r0,ctc_icondata+4
	CMP	r0,#-1
	BEQ	ctc_skipvalid2
	LDR	r2,ctc_iconoffset
	LDR	r1,ctc_icondata+8
	ADD	r2,r2,r1
	MOV	r1,#256
	STR	r2,ctc_icondata+4
	MOV	r3,r6
	ADD	r0,r0,r5
	BL	ctc_readstring
	BVS	ctc_failure4
ctc_skipvalid2
	B	ctc_createicon

ctc_createsprite
	LDR	r0,ctc_icondata
	ADD	r0,r0,r5
	MOV	r1,#256
	MOV	r2,#0
	MOV	r3,r6
	BL	ctc_readstring
	ADD	r0,r0,#7
	BIC	r0,r0,#3
	BL	rmalloc
	TEQ	r0,#0
	BEQ	ctc_failure4

	LDR	r3,ctc_icondata
	STR	r0,ctc_icondata
	MOV	r2,r0
	ADD	r0,r3,r5
	MOV	r1,#256
	MOV	r3,r6
	BL	ctc_readstring
	BVS	ctc_failure4

	LDR	r0,=canvas_templatespritearea
	LDR	r0,[r0]
	STR	r0,ctc_icondata+4

ctc_createicon
	LDR	r0,[r8,#window_handle]
	ADR	r1,ctc_iconwin
	STR	r0,[r1]
	SWI	XWimp_CreateIcon
	BVS	ctc_failure4
	LDR	r0,ctc_nicons
	SUBS	r0,r0,#1
	BMI	ctc_endicons
	STR	r0,ctc_nicons
	LDR	r0,ctc_iconno
	ADD	r0,r0,#1
	STR	r0,ctc_iconno
	B	ctc_createicons

ctc_endicons
	ADD	r13,r13,#ctc_size
	MOV	r1,r6
	MOV	r0,#0
	SWI	XOS_Find
	MOV	r0,r8
 [ arm32
	LDMFD	r13!,{r4-r9,pc}
 |
	LDMFD	r13!,{r4-r9,pc}^
 ]

ctc_readblock
; r0 is position to read from in file
; r1 is #bytes (max)
; r2 is pointer to write data to
; r3 is file handle
	STMFD	r13!,{r4-r6,lr}
	MOV	r5,r3
	MOV	r4,r0
	MOV	r3,r1
	MOV	r1,r5
	MOV	r0,#3
	ADD	r6,r2,r1
	SWI	XOS_GBPB
	LDMFD	r13!,{r4-r6,pc}

ctc_readstring
; r0 is position to read from in file
; r1 is #bytes (max)
; r2 is pointer to write data to
; r3 is file handle
; returns length in r0
	STMFD	r13!,{r4-r8,lr}
	MOV	r4,r0
	MOV	r5,r1
	MOV	r6,r2
	MOV	r7,r3

	MOV	r0,#1
	MOV	r1,r7
	MOV	r2,r4
	SWI	XOS_Args
	LDMVSFD	r13!,{r4-r8,pc}

	MOV	r8,#0

ctc_readloop
	ADD	r8,r8,#1
	TEQ	r8,r5
	BEQ	ctc_readend
	MOV	r1,r7
	SWI	XOS_BGet
	LDMVSFD	r13!,{r4-r8,pc}
	CMP	r0,#32
	BCC	ctc_readend
	TEQ	r6,#0
	STRNEB	r0,[r6],#1
	B	ctc_readloop
ctc_readend
	MOV	r0,#0
	TEQ	r6,#0
	STRNEB	r0,[r6],#1
	MOV	r0,r8			; return length
	LDMFD	r13!,{r4-r8,pc}

ctc_getstringlength
	STMFD	r13!,{r4-r6,lr}
	LDMFD	r13!,{r4-r6,pc}

ctc_failure4
	ADD	r1,r8,#window_handle
	SWI	XWimp_DeleteWindow
ctc_failure3
	ADD	r13,r13,#ctc_size
ctc_failure2
	MOV	r0,r8
	BL	rfree
ctc_failure1
	MOV	r1,r6
	MOV	r0,#0
	SWI	XOS_Find
	MOV	r0,#0
 [ arm32
	LDMFD	r13!,{r4-r9,pc}
 |
	LDMFD	r13!,{r4-r9,pc}^
 ]

	AREA	|____canvas_getcaretstate|, CODE, READONLY
	EXPORT	canvas_getcaretstate
canvas_getcaretstate

	MOV	r1,r0
	SWI	XWimp_GetCaretPosition
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_setcaretcolour|, CODE, READONLY
	EXPORT	canvas_setcaretcolour
canvas_setcaretcolour

	STRB	r1,[r0,#window+38]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_settitlelocation|, CODE, READONLY
	EXPORT	canvas_settitlelocation
canvas_settitlelocation

	STR	r1,[r0,#window+72]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_setminsize|, CODE, READONLY
	EXPORT	canvas_setminsize
canvas_setminsize

	ORR	r1,r1,r2,LSL#16
	STR	r1,[r0,#window+68]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____canvas_redrawmode|, DATA, NOINIT
	EXPORT	canvas_redrawmode
canvas_redrawmode

	DCD	0

	END
